/*
 * Created on Apr 11, 2005
 */
package com.sunlabs.archsim.fleet.HornAndFunnel;

import com.sunlabs.archsim.fleet.common.Payload;
import com.sunlabs.archsim.gasp.BranchAction;

/**
 *
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 * 
 * @author ib27688
 *
  * An action inside a fleet instruction horn. 
 * Branches on the basis of source 
 * 
 * The direction of the data is determined by the mask:
 * if address & mask == 0, then the data is sent to out[0], else it is sent to
 * out[1].
 */
public class DestinationHornBranchAction extends BranchAction {

	/* (non-Javadoc)
	 * @see com.sunlabs.archsim.gasp.BranchAction#selectBranch(java.lang.Object)
	 */

	protected static final String name= "DestinationHornBranchAction";

	protected final int mask;	
		
	public DestinationHornBranchAction(String id, int mask) {
		super(name+"_"+id, 2);
		// set the mask
		this.mask= mask;
	}
	
	/** 
	 * Choose the direction - use source
	 */
	public int selectBranch(Object data) {
		int selection= 0;
		if (data instanceof Payload) {
			Payload d= (Payload)data;
				selection = ((d.destination & mask) == 0)? 0 : 1;
		}
		else {
			director.fatalError("DestinationHornBranchAction " + getAlias() + ", id= " + getID()
				+ ": Unrecognized object type"
				+ data.getClass().getName() + "instead of Payload");
		}
		return selection;
	} // selectBranch
	
} // DestinatinHornBranchAction
